/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.records.TCoreUmlsimportRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreUmlsimport extends TableImpl<TCoreUmlsimportRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_umlsimport</code>
     */
    public static final TCoreUmlsimport T_CORE_UMLSIMPORT = new TCoreUmlsimport();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreUmlsimportRecord> getRecordType() {
        return TCoreUmlsimportRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_umlsimport.lastchange</code>.
     */
    public final TableField<TCoreUmlsimportRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_umlsimport.pk</code>. unique id
     */
    public final TableField<TCoreUmlsimportRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "unique id");

    /**
     * The column <code>common_dd.t_core_umlsimport.content</code>. jsonb
     * content of the result of the query
     */
    public final TableField<TCoreUmlsimportRecord, JSONB> CONTENT = createField(DSL.name("content"), SQLDataType.JSONB.nullable(false), this, "jsonb content of the result of the query");

    /**
     * The column <code>common_dd.t_core_umlsimport.query</code>. the MDM rest
     * query
     */
    public final TableField<TCoreUmlsimportRecord, String> QUERY = createField(DSL.name("query"), SQLDataType.CLOB.nullable(false), this, "the MDM rest query");

    private TCoreUmlsimport(Name alias, Table<TCoreUmlsimportRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreUmlsimport(Name alias, Table<TCoreUmlsimportRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_umlsimport</code> table
     * reference
     */
    public TCoreUmlsimport(String alias) {
        this(DSL.name(alias), T_CORE_UMLSIMPORT);
    }

    /**
     * Create an aliased <code>common_dd.t_core_umlsimport</code> table
     * reference
     */
    public TCoreUmlsimport(Name alias) {
        this(alias, T_CORE_UMLSIMPORT);
    }

    /**
     * Create a <code>common_dd.t_core_umlsimport</code> table reference
     */
    public TCoreUmlsimport() {
        this(DSL.name("t_core_umlsimport"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_UMLSIMPORT_QUERY);
    }

    @Override
    public Identity<TCoreUmlsimportRecord, Integer> getIdentity() {
        return (Identity<TCoreUmlsimportRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreUmlsimportRecord> getPrimaryKey() {
        return Keys.PK_CORE_UMLSIMPORT;
    }

    @Override
    public List<UniqueKey<TCoreUmlsimportRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_UMLSIMPORT);
    }

    @Override
    public TCoreUmlsimport as(String alias) {
        return new TCoreUmlsimport(DSL.name(alias), this);
    }

    @Override
    public TCoreUmlsimport as(Name alias) {
        return new TCoreUmlsimport(alias, this);
    }

    @Override
    public TCoreUmlsimport as(Table<?> alias) {
        return new TCoreUmlsimport(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUmlsimport rename(String name) {
        return new TCoreUmlsimport(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUmlsimport rename(Name name) {
        return new TCoreUmlsimport(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreUmlsimport rename(Table<?> name) {
        return new TCoreUmlsimport(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmlsimport where(Condition condition) {
        return new TCoreUmlsimport(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmlsimport where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmlsimport where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmlsimport where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmlsimport where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmlsimport where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmlsimport where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreUmlsimport where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmlsimport whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreUmlsimport whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
